# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_返利发放列表,2271,2271-39,sit,bs
主数据平台:后台运营系统返利发放明细查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import random
import requests
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利发放明细
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url33")
request_body = commonFuc().get_business_data(module, "payload33")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数字
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取返利信息
status = result["data"]["list"][rebate_random]["status"]
rebate_theme = result["data"]["list"][rebate_random]["rebateTheme"]
customer_name = result["data"]["list"][rebate_random]["rebatetripCusList"][0]["customerName"]
customer_code = result["data"]["list"][rebate_random]["rebatetripCusList"][0]["customerCode"]
product_name = result["data"]["list"][rebate_random]["rebatetripProList"][0]["productName"]
product_code = result["data"]["list"][rebate_random]["rebatetripProList"][0]["productCode"]

# 第三步进行返利发放信息查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url34")
request_body = commonFuc().get_business_data(module, "payload34", status, rebate_theme, customer_name, customer_code,
                                             product_name, product_code)

"""
 场景: 列表查询条件验证_返利发放列表
 用例名称：列表查询条件验证_返利发放列表
 输出：{"rebateTheme":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 获取查询结果中的返利信息
result = {"rebateTheme": result["data"]["list"][0]["rebateTheme"]}
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict34", rebate_theme)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
