# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc批量新增_套包正价,2264,2264-51,sit,bs
主数据平台:运营后台管理系统套包批量新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import os
import random


module = "cmdc_special_fresenius_group"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers2", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/套包正价批量导入模板.xlsx"

# 第二步获取套包列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url25")
request_body = commonFuc().get_business_data(module, "payload25")
# 发送请求
result = requests.post(url, headers=headers, json=request_body)
result = json.loads(result.content)

# 随机获取套包信息
group_id_a = random.randint(1, len(result["data"]["list"]) - 1)

group_code = result["data"]["list"][group_id_a]["groupCode"]
group_name = result["data"]["list"][group_id_a]["groupName"]
print(group_name)
# 初始值
row = 2

for i in result["data"]["list"][group_id_a]["products"]:
    # 第三步，将商品信息写入文件中
    excel = HandleExcel(file_path, "Sheet1")

    excel.write_data(row, column=1, value=group_code)
    excel.write_data(row, column=2, value=group_name)
    excel.write_data(row, column=3, value=i["productCode"])
    excel.write_data(row, column=4, value=i["productName"])
    excel.write_data(row, column=5, value=group_id_a)
    row = row + 1

# 第四步，进行文件导入操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url26")
print(url)
# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""
场景:批量新增_套包商品管理
用例名称：批量新增_套包商品管理
输出：{"success":true,"code":"200","message":"OK","data":{"success":true},"freshToken":null}
"""
print(headers)
# 发送请求
result = requests.post(url, files=files, headers=headers)
result = json.loads(result.content)
file.close()
print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict12")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
