# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc商品清单获取验证_结算页面,2288,2288-19,sit,bs
涉及到接口:多采商城获取商品清单接口
"""

from common.common_func import commonFuc
import requests
import json

module = "cmdc_order_handle"

# 获取商品清单信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url15")
request_body = commonFuc().get_business_data(module, "payload15")

"""

 场景: 商品清单获取验证_结算页面
 用例名称：商品清单获取验证_结算页面
 输出：{"success":true,"code":"200","message":"OK"}
"""

# 发送请求
result = requests.get(url, params=request_body)
result = json.loads(result.content)
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict15")
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
